using System;
using NUnit.Framework;

using Smdn.Text;

namespace Smdn.Net.Imap4.Protocol {
  [TestFixture]
  public class ImapMalformedDataExceptionTests {
    [Test]
    public void TestSerializeBinary_CausedDataNull()
    {
      var ex = new ImapMalformedDataException();

      Assert.IsNull(ex.CausedData);

      TestUtils.Assert.IsSerializableBinaryFormat(ex, delegate(ImapMalformedDataException deserialized) {
        Assert.IsNull(deserialized.CausedData);
      });
    }

    [Test]
    public void TestSerializeBinary_CausedDataNotNull()
    {
      var ex = new ImapMalformedDataException(ImapData.CreateTextData(ByteString.CreateImmutable("exception")));

      Assert.IsNotNull(ex.CausedData);

      TestUtils.Assert.IsSerializableBinaryFormat(ex, delegate(ImapMalformedDataException deserialized) {
        Assert.IsNotNull(deserialized.CausedData);
        Assert.AreEqual("exception", deserialized.CausedData.GetTextAsString());
      });
    }
  }
}